#include <wxnc/app.hpp>
#include <wxnc/frame.hpp>
#include <cstdlib>
#include <ncurses.h>
#include <unistd.h>
#include "internal.h"

void wxnc_clear_area(int sx, int sy, int ex, int ey, unsigned int attr)
{
	attrset(attr);
	wxnc_clear_area(sx, sy, ex, ey);
}

void wxnc_clear_area(int sx, int sy, int ex, int ey)
{
	int x, y;

	for (y = sy; y < ey; ++y)
		for (x = sx; x < ex; ++x)
			mvaddch(y, x, ' ');
}

static void wxnc_init(void)
{
	initscr();

	start_color();
	if (!has_colors())
		return;

	assume_default_colors(0, 0);
	for (int i = 0; i < COLOR_PAIRS; ++i)
		init_pair(i, i % 8, i / 8);
}

static void wxnc_mainloop(void)
{
	wxncGetApp().render();
	refresh();
}

extern "C" int wxncEntry(int argc, char **argv)
{
	wxnc_init();
	wxncGetApp().OnInit();
	wxnc_mainloop();
	fgetc(stdin);
	endwin();
	delwin(stdscr);

	return EXIT_SUCCESS;
}

wxncApp::wxncApp(void) :
	app_frame(NULL)
{
}

wxncApp::~wxncApp(void)
{
	delete app_frame;
}

bool wxncApp::OnInit(void)
{
	return true;
}

void wxncApp::replace_frame(wxncFrame *frame)
{
	delete app_frame;
	app_frame = frame;
}

void wxncApp::render(void)
{
	if (app_frame != NULL)
		app_frame->wxncWindow::Refresh();
}
