#ifndef WXNC_FRAME_HPP
#define WXNC_FRAME_HPP 1

#include <wxnc/color.hpp>
#include <wxnc/toplevel.hpp>
#include <wx/defs.h>
#include <wx/gdicmn.h>
#include <wx/string.h>
#include <wx/toplevel.h>

class wxncBackFrame;
class wxncMenuBar;
class wxncStatusBar;
class wxncWindow;

class wxncFrame : public wxncTopLevelWindow {
    public:
	wxncFrame(wxncWindow *, wxWindowID = wxID_ANY,
		const wxString & = wxEmptyString,
		const wxPoint & = wxDefaultPosition,
		const wxSize & = wxDefaultSize, long = wxDEFAULT_FRAME_STYLE,
		const wxString & = wxEmptyString);
	virtual ~wxncFrame(void);

	wxncStatusBar *CreateStatusBar(int = 1, long = wxST_SIZEGRIP,
		wxWindowID = wxID_ANY, const wxString & = wxEmptyString);
	void SetMenuBar(wxncMenuBar *);
	void SetStatusBar(wxncStatusBar *);
	void SetStatusText(const wxString &, int = 0);
	void RecalcSizes(void);
	void Layout(void);
	void Update(void);

    protected:
	wxncMenuBar *m_menubar;
	wxncStatusBar *m_statusbar;

    private:
	void render_background(int, int, int, int);

	wxncBackFrame *m_backframe;
	wxncColor m_ckcolor;
};

#endif /* WXNC_FRAME_HPP */
